/*****************************************************
This program was produced by the
CodeWizardAVR V2.04.4a Advanced
Automatic Program Generator
 Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 26.08.2012
Author  : NeVaDa
Company : 
Comments: 


Chip type               : ATmega16
Program type            : Application
AVR Core Clock frequency: 13,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega16.h>
#include <stdlib.h>
#include <delay.h>
#include "GPM388CO.h"
#include <sleep.h>
#include <io.h>

// I2C Bus functions
#asm
   .equ __i2c_port=0x18 ;PORTB
   .equ __sda_bit=1
   .equ __scl_bit=0
#endasm
#include <i2c.h>

typedef struct{
    unsigned char tick; 
    unsigned char second;
    unsigned char minute;
    unsigned char hour;    
}time;
 
time t;

char reg=0,regold=0,tflag,i,intflag=0;
char stroka[4]="   ",sms[3];
const char tst[10][10]={"         ","  ","   ","  "," 1 ",
                              " 2 "," 3 ","COM<>RF  "," ",""};

//  
unsigned char data,inkey,key,keyold=0,ikey=0,tkey=12,slen=1,ack=1;
unsigned char data_rf,rfxx_flag=1,w0,w1,inbuff[7],crc_in,rfto_flag=1;

#define BUF_SIZE    32  //     !
#define BUF_MASK    (BUF_SIZE-1)

volatile unsigned char idxIN=0, idxOUT=0;
volatile unsigned char buffer [BUF_SIZE]; 

//  
char xas=16,yas=16,xin,yin,rfm=0;
unsigned int temp,status_rf;

#define keyred 0x20
#define keyu 0x02
#define keyd 0x04
#define keyr 0x01
#define keyl 0x08
#define keyc 0x06
#define keyg 0x09
#define keyrs 0x25
#define keyls 0x2c
#define keys 0x10
#define keyforv 0x12
#define keyback 0x14
#define keyleft 0x18
#define keyright 0x11
#define keylset 0x0c
#define keyrset 0x05
#define keylight 0x3c
#define keyhorn 0x35
#define keydrive 0x30
#define keyset1 0x28
#define keyset2 0x22
#define keyset3 0x28
#define keycom 0x24
#define keysettime 0x41
#define keyacs 0x29
#define keyout 0x44

#ifndef RXB8
#define RXB8 1
#endif

#ifndef TXB8
#define TXB8 0
#endif

#ifndef UPE
#define UPE 2
#endif

#ifndef DOR
#define DOR 3
#endif

#ifndef FE
#define FE 4
#endif

#ifndef UDRE
#define UDRE 5
#endif

#ifndef RXC
#define RXC 7
#endif

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<DOR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

// USART Receiver buffer
#define RX_BUFFER_SIZE 32
char rx_buffer[RX_BUFFER_SIZE];

#if RX_BUFFER_SIZE<256
unsigned char rx_wr_index,rx_rd_index,rx_counter;
#else
unsigned int rx_wr_index,rx_rd_index,rx_counter;
#endif

// This flag is set on USART Receiver buffer overflow
bit rx_buffer_overflow;

// USART Receiver interrupt service routine
interrupt [USART_RXC] void usart_rx_isr(void)
{
char status,data;
status=UCSRA;
data=UDR;
if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
   {
   rx_buffer[rx_wr_index]=data;
   if (++rx_wr_index == RX_BUFFER_SIZE) rx_wr_index=0;
   if (++rx_counter == RX_BUFFER_SIZE)
      {
      rx_counter=0;
      rx_buffer_overflow=1;
      };
   };
}

#ifndef _DEBUG_TERMINAL_IO_
// Get a character from the USART Receiver buffer
#define _ALTERNATE_GETCHAR_
#pragma used+
char getchar(void)
{
char data;
while (rx_counter==0);
data=rx_buffer[rx_rd_index];
if (++rx_rd_index == RX_BUFFER_SIZE) rx_rd_index=0;
#asm("cli")
--rx_counter;
#asm("sei")
return data;
}
#pragma used-
#endif

// Standard Input/Output functions
#include <stdio.h>

// Timer2 overflow interrupt service routine
interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{

   if (++t.tick==4)
    {
      t.tick=0;tflag=1; 
   if (++t.second==60)       
    {
        t.second=0;
         if (++t.minute==60) 
        {
            t.minute=0;
             if (++t.hour==24)
            {
                t.hour=0;
                
            }
        }
    } 
  } 

}

#define ADC_VREF_TYPE 0x60

// Read the 8 most significant bits
// of the AD conversion result
unsigned char read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCH;
}

/// RFM12  

unsigned int RFXX_WRT_CMD(unsigned int aCmd) // 
{
unsigned char i;
unsigned int temp=0;
PORTB.7=0;
PORTB.4=0;
for(i=0;i<16;i++)
   {
   if(aCmd&0x8000) PORTB.5=1;
   else PORTB.5=0;
   PORTB.7=1;
   temp<<=1;
   if(PINB.6) temp|=0x0001;
   PORTB.7=0;
   aCmd<<=1;
   }
PORTB.4=1;
return(temp);
}

void RF12_INIT(void) //
{
while (!PIND.2) RFXX_WRT_CMD(0x0000);

RFXX_WRT_CMD(0x80E7);//EL,EF,868band,12pF
RFXX_WRT_CMD(0x8219);//!er,!ebb,!ET,ES,EX,!eb,!ew,DC
RFXX_WRT_CMD(0xA640);//=868MHz
RFXX_WRT_CMD(0xC647);//06->57.6kbps 47->4.8kbps
RFXX_WRT_CMD(0x94C0);//VDI,FAST,67kHz,0dBm,-103dBm
RFXX_WRT_CMD(0xC2AC);//AL,!ml,DIG,DQD4
RFXX_WRT_CMD(0xCAB0);//FIFO11,SYNC,!ff,DR
RFXX_WRT_CMD(0xC4F3);//@PWR,NO RSTRIC,!st,!fi,OE,EN
RFXX_WRT_CMD(0x9820);//!mp,45kHz,MAX OUT
RFXX_WRT_CMD(0xCC07);
RFXX_WRT_CMD(0xE000);//NOT USE
RFXX_WRT_CMD(0xC800);//NOT USE
RFXX_WRT_CMD(0xC000);//1MHz,2.2V
}

void RF12_SEND(unsigned char aByte)
{
while(!(RFXX_WRT_CMD(0x0000)&0x8000));
RFXX_WRT_CMD(0xB800+aByte);
}
// External Interrupt 0 service routine
interrupt [EXT_INT0] void ext_int0_isr(void)
{
status_rf=RFXX_WRT_CMD(0x0000);
data_rf=(char)((RFXX_WRT_CMD(0xB000))&0x00FF);
rfxx_flag=0;
//buffer[idxIN++]=(char)((RFXX_WRT_CMD(0xB000))&0x00FF);
//idxIN &= BUF_MASK;
}
void fifo_reset(void)
  {
  RFXX_WRT_CMD(0xCAB0);
  RFXX_WRT_CMD(0xCAB2);
  } 
  
void RF12_tx_on(void)
  {
   RFXX_WRT_CMD(0x80E7);
   RFXX_WRT_CMD(0x8239);
  }
  
void RF12_rx_on(void)
  {
   RFXX_WRT_CMD(0x80E7);
   RFXX_WRT_CMD(0x8299);
   fifo_reset();
  }
  
unsigned char idxDiff (unsigned char idxIN, unsigned char idxOUT)
{
return (idxIN - idxOUT)&BUF_MASK;
}

unsigned char rrx_data (unsigned char idxOUT)
 {
 unsigned char value;
 value = buffer[idxOUT];
 idxOUT &= BUF_MASK;
 return value;
 }
 
//Internal
void set_row_clm(unsigned char row,unsigned char clm)//   
  {  
  if((row < 8)&(clm < 98))
   {
   i2c_start();
   i2c_write(0x78);i2c_write(0x00);i2c_write(0x28);i2c_write(row + 0x40);i2c_write(clm + 0x80);
   i2c_stop();
   }
  }
void write_column(unsigned char dat_byte)//    
  {                                                       
   //                                                                           
   i2c_start();
   i2c_write(0x78);i2c_write(0x40);i2c_write(dat_byte);
   i2c_stop();
  }
//External
void clear_lcd(void)//  
  {
  int i; 
  i2c_start();
  i2c_write(0x78);
  i2c_write(0x40);
  for(i = 0; i < 918; i++)
  {
   i2c_write(0x00); 
  } 
  i2c_stop(); 
  } 
void GPM388CO_init(void)//  
  {                     
  
  delay_ms(10);
  
  i2c_start();
  i2c_write(0x78);i2c_write(0x00);i2c_write(0x29);i2c_write(0x14);
  i2c_write(0x06);i2c_write(0x28);i2c_write(0x11);i2c_write(0x05);
  i2c_write(0x29);i2c_write(0x9A);i2c_write(0x0C);i2c_write(0x28);
  i2c_write(0x0C);i2c_write(0x40);i2c_write(0x80);
  i2c_stop();
  
  i2c_start();
  i2c_write(0x78);i2c_write(0x00);
  i2c_write(0x29);i2c_write(0x9A);
  i2c_stop();
   clear_lcd();
  }
  
             
void LcdPutLine(unsigned char *data, unsigned char line, unsigned char clm, unsigned char mode)
//    
  {
   unsigned int i;
   unsigned char ch;
   unsigned char chr_coutnt = 0; 
      
   set_row_clm(line,clm);
    
   i2c_start();
   i2c_write(0x78);i2c_write(0x40); 
     
   	while (*data)
	{    
        if(chr_coutnt > 15)
         { 
          chr_coutnt = 0;
          line++;clm = 0;
          set_row_clm(line,clm);
          i2c_start();
          i2c_write(0x78);i2c_write(0x40); 
         }
	   	for(i=0; i<5; i++)
		{
	     ch = FontLookup[*data - 32][i] << 1;
	     	if(mode)
			{
			i2c_write(~ch);
			}
	        else
			{
			i2c_write(ch);
			}
	     if(i == 4)
		 {
		  if(mode) 
		   {  
		    i2c_write(0xff);
		    }
		   else
		   {   
		    i2c_write(0x00);
		   } 
		}
      }
      data++;
      chr_coutnt++;  
      }	   
  } 
void LcdBarLine(unsigned char line, unsigned char row, unsigned char clm)
 //  
 {
      set_row_clm(row,clm);
      for (i=0;i<line;i++) write_column(0xFF); 
      for (i=line;i<66;i++) write_column(0x00);
  } 

void probel (void) {
  for (i=0;i<12;i++) write_column(0x00);
  }
  
    //  
unsigned char keypress (void)
  { 
  char skey;
  key=(~PINC)&0x3f;
  if (key) ikey++,delay_ms(1); 

  if ((key!=keyold)&&(keyold==0))
    {
      PORTA.4=1,PORTD.6=1,delay_ms(50),PORTA.4=0,PORTD.6=0;
    };
    
  if (key!=keyold)
    {
    skey=keyold;
    keyold=key;
    if (key) ikey=0;
    }
    
  if (ikey&&(ikey<tkey)&&(key==0)) 
      {
      ikey=0;
      keyold=0;
      return skey;
      } 
      
  if ((ikey==tkey)&&(key)) 
        { 
           PORTA.4=1,PORTD.6=1,delay_ms(50),PORTA.4=0;
           delay_ms(50);PORTD.6=0;
           key=key+0x40;
           ikey=0;
           //keyold=0;
         return key;
        };      
    
  if (ikey) return 0x3f;
  return 0;
  } 
  
  //  
void showtime (void)
  {
   if (tflag)
        {
        itoa(t.hour,stroka);
        LcdPutLine(stroka,0,24,0);
        for (i=0;i<6;i++) write_column(0x00);
        itoa( t.minute,stroka);
        LcdPutLine(stroka,0,42,0);
        for (i=0;i<6;i++) write_column(0x00);
        itoa(t.second,stroka);
        LcdPutLine(stroka,0,60,0);
        for (i=0;i<6;i++) write_column(0x00); 
        itoa(reg,stroka);
        LcdPutLine(stroka,0,78,0);
        for (i=0;i<6;i++) write_column(0x00); 
        };
        tflag=0;
        
  }
void rtx_pack (unsigned char ack)
  {
   unsigned char crc,ar1,ar2;
   ar1=0xAA;
   ar2=(~PINC)&0x0f;;
   //ar3=read_adc(6);    
   
   crc=0x80%0x31;
   crc=(crc+xas)%0x31;
   crc=(crc+yas)%0x31;
   crc=(crc+ar2)%0x31;
   crc=(crc+ar1)%0x31;
   crc=(crc+ack)%0x31;
  RF12_SEND(0xAA);//PREAMBLE
  RF12_SEND(0xAA);//PREAMBLE
  RF12_SEND(0xAA);//PREAMBLE
  RF12_SEND(0x2D);//SYNC HI BYTE
  RF12_SEND(0xD4);//SYNC LOW BYTE
  RF12_SEND(0x20);
  RF12_SEND(0x6a);
  RF12_SEND(0x80);
  RF12_SEND(xas);
  RF12_SEND(yas);
  RF12_SEND(ar2);
  RF12_SEND(ar1);
  RF12_SEND(ack);
  RF12_SEND(crc);
  RF12_SEND(0xAA);//DUMMY BYTE
  RF12_SEND(0xAA);//DUMMY BYTE
  };
       
// Declare your global variables here
// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
if (++intflag==100) intflag=0,rfto_flag=0;

}

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=Out Func3=Out Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=0 State3=0 State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x18;

// Port B initialization
// Func7=Out Func6=In Func5=Out Func4=Out Func3=Out Func2=In Func1=Out Func0=Out 
// State7=0 State6=P State5=0 State4=1 State3=0 State2=P State1=0 State0=0 
PORTB=0x54;
DDRB=0xBB;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=P State4=P State3=P State2=P State1=P State0=P 
PORTC=0x3F;
DDRC=0x00;

// Port D initialization
// Func7=Out Func6=Out Func5=Out Func4=In Func3=In Func2=In Func1=Out Func0=In 
// State7=0 State6=1 State5=0 State4=T State3=P State2=P State1=0 State0=P 
PORTD=0x4D;
DDRD=0xE2;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 12,695 kHz
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x05;
//TCCR0=0x00;
TCNT0=0x00;
OCR0=0x80;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 13000,000 kHz
// Mode: CTC top=OCR1A
// OC1A output: Toggle
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x40;
TCCR1B=0x09;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x32;
OCR1AL=0xC8;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: TOSC1 pin
// Clock value: PCK2/32
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x08;
TCCR2=0x03;
TCNT2=0x00;
OCR2=0x00;


// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Falling Edge
// INT1: Off
// INT2: Off
GICR|=0x40;
MCUCR=0x02;
MCUCSR=0x00;
GIFR=0x40;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x41;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 115200
UCSRA=0x00;
UCSRB=0x98;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x06;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC Clock frequency: 812,500 kHz
// ADC Voltage Reference: AVCC pin
// ADC Auto Trigger Source: None
// Only the 8 most significant bits of
// the AD conversion result are used
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0x84;

// I2C Bus initialization
i2c_init();
PORTD.6=0;//
//
if (PINC.5) delay_ms(1000);
if (PINC.5) PORTD.7=1;


GPM388CO_init();
// FRM12
RF12_INIT();
RF12_rx_on();

// 
t.tick=0;t.second=0;t.minute=0;t.hour=0;
// Global enable interrupts
#asm("sei")

while (1)
      { 
       if ((reg==0)||(reg==1)) {
       sleep_enable();  //  SLEEP.
       powersave();       //  .
       sleep_disable(); //  SLEEP.
       }
       else sleep_disable(); //  SLEEP. 
            
             // 
        inkey=keypress(); 
        if (inkey!=0x3f)
        {
        itoa (inkey,stroka),LcdPutLine(stroka,5,18,0);
        for (i=0;i<12;i++) write_column(0x00);
        };
          if (inkey==keysettime) regold=0,reg=8; 
          if (inkey==keyc) PORTA.3=!PORTA.3; // 
          if (inkey==0x56) 
           {
            regold=0,reg=9; //  9  
            RF12_tx_on();
           };  
          if (inkey==0x51) 
           {
            regold=0,reg=7; //  7    
            RF12_rx_on();
           }; 
          if (inkey==0x58) 
           {
           regold=0,reg=6; //  6   
           RF12_rx_on();
           }; 
                
        //    
       showtime ();
         
       if (reg==0)  //   
       {
       regold=0;
       };
         //  
       if (PIND.4)
         { 
         if (reg!=1) regold=reg;
         reg=1;
         }
       
       
       if (reg==1)   //   
       { 
         if ((PIND.4)&(read_adc(2)>0x09))
         { 
         sms[0]=0x81;
         sms[1]=0x20;
         LcdPutLine(tst[1],3,18,0);
         }
        if ((PIND.4)&(read_adc(2)<0x0a))  
         {
         sms[0]=0x46;
         sms[1]=0x4c;
         LcdPutLine(tst[0],3,18,0);
         };
        if (!PIND.4)
         {
         sms[0]=0x20;
         sms[1]=0x20;   
         
         LcdPutLine(tst[0],3,18,0);
         if (!regold) PORTD.7=0;
         else reg=regold;
         };
         sms[2]=0x00;
         LcdPutLine(sms,0,90,0);
        
        };
        
       if (reg==8)   //   
       {   
        LcdPutLine(tst[8],3,18,0);
        inkey=keypress();
        if ((inkey==keyl)&(t.hour<24)) t.hour++;
        if (t.hour==24) t.hour=0;
        if ((inkey==keyu)&(t.minute<60)) t.minute=t.minute+10;
        if ((inkey==keyr)&(t.minute<60)) t.minute++;
        if (t.minute>59) t.minute=0;
        if (inkey==0x50) reg=regold,LcdPutLine(tst[0],3,18,0);// 
        tflag=1;
        
       }; 
       
       if (reg==9)   //  
       { 
         //
       yin=(read_adc(6))-75;
       xin=(read_adc(1))-79; 
         
       itoa (yas,stroka),LcdPutLine(stroka,7,20,0);
       for (i=0;i<12;i++) write_column(0x00); 
       LcdBarLine(yas<<1,7,32);
       itoa (xas,stroka),LcdPutLine(stroka,6,20,0);
       for (i=0;i<12;i++) write_column(0x00);
       LcdBarLine(xas<<1,6,32); 
       rtx_pack(0x20);
        if ((xas<31)&&(xin>75)) xas++;
        if ((xas>1)&&(xin<25)) xas--;
        if ((yas<31)&&(yin>82)) yas++;
        if ((yas>1)&&(yin<40)) yas--;
        if ((xas>16)&&((xin<75)&&(xin>25))) xas--;
        if ((xas<16)&&((xin<75)&&(xin>25))) xas++; 
        if (inkey==0x50)           //  
        {
         set_row_clm(6,20);
         for (i=0;i<180;i++) write_column(0x00);
         reg=regold,slen=1,LcdPutLine(tst[0],3,18,0);
         RF12_rx_on();
        }; 
        };
         
       if (reg==7)      //   
       {  
         w0=0;w1=0;crc_in=0;
lb1:       //clear_lcd();
           while (!(data_rf==0x2D)&&rfto_flag) {rfxx_flag=1;};
           if (!rfto_flag) goto lb2;
           rfxx_flag=1;
           while (rfxx_flag) {};
           rfxx_flag=1;
           while (rfxx_flag) {};
           rfxx_flag=1;
           while (rfxx_flag) {};      //  
           rfxx_flag=1;
          while (rfxx_flag) {};
          inbuff[0]=data_rf,rfxx_flag=1,crc_in=inbuff[0]%0x31; 
          while (rfxx_flag) {};          
          inbuff[1]=data_rf,rfxx_flag=1,crc_in=(crc_in+inbuff[1])%0x31; 
          while (rfxx_flag) {}; 
          inbuff[2]=data_rf,rfxx_flag=1,crc_in=(crc_in+inbuff[2])%0x31;
          while (rfxx_flag) {};  
          inbuff[3]=data_rf,rfxx_flag=1,crc_in=(crc_in+inbuff[3])%0x31;
          while (rfxx_flag) {};  
          inbuff[4]=data_rf,rfxx_flag=1,crc_in=(crc_in+inbuff[4])%0x31;
          while (rfxx_flag) {};  
          inbuff[5]=data_rf,rfxx_flag=1,crc_in=(crc_in+inbuff[5])%0x31;
          while (rfxx_flag) {};                        
          inbuff[6]=data_rf,rfxx_flag=1; 
                                       
          if (!(inbuff[6]==crc_in)) goto lb1;  // 
                                      
lb2:      rfto_flag=1,intflag=0;      
         // itoa (intflag,stroka),LcdPutLine(stroka,0,80,0); 
          itoa (inbuff[0],stroka),LcdPutLine(stroka,1,20,0),probel();
          itoa (inbuff[1],stroka),LcdPutLine(stroka,1,60,0),probel();
          itoa (inbuff[2],stroka),LcdPutLine(stroka,2,20,0),probel();
          itoa (inbuff[3],stroka),LcdPutLine(stroka,2,60,0),probel();
          itoa (inbuff[4],stroka),LcdPutLine(stroka,3,20,0),probel();
          itoa (inbuff[6],stroka),LcdPutLine(stroka,3,60,0),probel();
          
          itoa (read_adc(5),stroka),LcdPutLine(stroka,5,60,0),probel();
          if (inkey==0x10)
        {
         inkey=0x3f;clear_lcd();
         reg=0;
        };
       };
       
         
       if (reg==6)      //    
       { 
         while((rfxx_flag==1)&&PINC.4&&rfto_flag);
         rfxx_flag=1,rfto_flag=1;
         itoa (data_rf,stroka),LcdPutLine(stroka,6,60,0),probel(); 
         itoa (status_rf,stroka),LcdPutLine(stroka,6,10,0),probel();
         itoa (read_adc(5),stroka),LcdPutLine(stroka,5,60,0),probel();
         if (inkey==0x50)
           {
            inkey=0x3f;clear_lcd();
            reg=0;
           };
        };
        
         if (inkey==0x50)
        {
         if (rfm) PORTA.3=0,PORTD.7=0; 
         if (reg==0) rfm=1;
         else rfm=0;
         reg=0,LcdPutLine(tst[0],3,18,0);
        };

      };
}
